
#declare mu = 0.3;

#default{
 finish{
  ambient 0.3
  diffuse 0.7
 }
}

#declare Omega = function{ (pow(x,2) + pow(z, 2))/2 + (1-mu)/sqrt(pow(x + mu, 2) + pow(y, 2) + pow(z, 2)) + mu/sqrt(pow(x + mu - 1, 2) + pow(y, 2) + pow(z, 2)) }


#declare LSolve = poly{ 5,
 <1,
  0, 0, 2*(2*mu-1),
  0, 0, 0, 0, 0, (1-6*mu*(1-mu)),
  0, 0, 0, 0, 0, (1-mu), 0, 0, mu, 2*mu*(1-mu)*(1-2*mu),
  0, 0, 0, 0, 0, 0, 0, 0, 0, -2*pow(1-mu, 2), 0, 0, 0, 2*pow(mu, 2), pow(mu*(1-mu), 2),
  0,
  0, 0,
  0, 0, 0,
  0, 0, 0, 0,
  0, 0, 0, 0, pow(1-mu, 3),
  0, 0, 0, 0, pow(mu, 3), 0
 >
}

#declare L1 = <trace(LSolve, < -mu, -1,  1>, x).x, 0, 0>;
#declare L2 = <trace(LSolve, <1-mu, -1, -1>, x).x, 0, 0>;
#declare L3 = <trace(LSolve, < -mu,  1,  1>,-x).x, 0, 0>;
#declare L4 = <0.5-mu, 0, sqrt(3)/2>;
#declare L5 = L4*<1, 1, -1>;


#declare rBase = 0.07;

#macro planet(pos, mass)
 sphere{ pos, rBase*pow(3*abs(mass), 1/3) pigment{ #if(mass>0) rgb <0.5, 0.5, 0.5> #else rgb <0.7, 0, 0> #end } }
#end

planet(<1-mu, 0, 0>, mu)
planet(<-mu, 0, 0>, 1-mu)

#declare Levels = array[3]{
//((1-mu*(1-mu))/2+1+0.01),
Omega(L3.x, 0, 0),
Omega(L2.x, 0, 0),
Omega(L1.x, 0, 0)//,
//(Omega(L1.x, 0, 0)+1)
}

#declare pointMark = sphere{ 0, 0.05
 pigment{
  object{
   union{
    box{ <1, 1, 1>, <0, -1, 0> }
    box{ <-1, 1, -1>, <0, -1, 0> }
   }
   rgb <1, 1, 1>, rgb <0.2, 0.2, 0.2>
  }
 }
 finish{ ambient 0.5 diffuse 0.5 }
}
#macro markPoint(point, name)
union{
 object{ pointMark }
 text{
  ttf "verdana.ttf" name 1, 0
  pigment{ rgb <1, 1, 1> }
  finish{ ambient 0 diffuse 0.5 brilliance 5 }
  scale <0.2, 0.2, 0.1>
  rotate <80, 0, 0>
  translate <0.02, 0.1, 0.1>
 }
 translate point
}
#end

markPoint(L1, "L1")
markPoint(L2, "L2")
markPoint(L3, "L3")
markPoint(L4, "L4")
markPoint(L5, "L5")


#local pmax = (3-mu*(1-mu))/2;

#declare fs = function(x) {
 max(1-exp(-x), 0)
}


plane{
 y, 0
 hollow no_shadow
 texture{
  pigment{
   function{
    fs(Omega(x, y, z)-pmax)
   }
   color_map{
    [ 0, rgb <1, 1, 1> ]
    [ 1/6, rgb <1, 0, 0> ]
    [ 2/6, rgb <0.95, 0.95, 0> ]
    [ 3/6, rgb <0, 0.97, 0> ]
    [ 4/6, rgb <0, 0.9, 0.9> ]
    [ 5/6, rgb <0, 0, 0.9> ]
    [ 1, rgb <0, 0, 0> ]
   }
  }
  finish{
   ambient 1
   diffuse 0
  }
 }
 /*
 texture{
   pigment{
     function{ select(
       -1
       #local k = dimension_size(Levels, 1);
       #while (k>0)
         #local k = k-1;
         #local c = Levels[k];
         *(Omega(x, y, z)-c)
       #end
       , 1, 0) }
     color_map{
       [ 0, rgbt 1 ]
       [ 1, rgbt <0, 0, 0, 0.7> ]
     }
   }
   finish{ diffuse 0 ambient 1 }
 }
 */
}
light_source{ <1/2-mu, 100, 0> color rgb 1 shadowless }

camera{

 orthographic

 right (5*image_width/image_height)*x
 up 5*y
 direction 5*z

 sky z

 location <0, 8, 0>
 look_at 0
}
